"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const js_funcs_1 = require("js-funcs");
class ExpressRes {
    constructor(expressEx) {
        this.error = (res, msg, code = 400) => {
            res.send({
                code,
                msg,
            });
        };
        this.done = (res, map) => {
            const { msg, code, data } = Object.assign({
                msg: "",
                code: 200,
                data: {},
            }, js_funcs_1.valid.type(map) === "string" ? { msg: map } : map);
            res.send(Object.assign({ code,
                msg }, data));
        };
        this.notFind = (res, msg = "数据不存在", code = 202) => {
            return res.send({
                code,
                msg,
            });
        };
        this.missData = (res, msg = "缺少数据", code = 202) => {
            return res.send({
                code,
                msg,
            });
        };
        this.valid = (res, isDone, msg) => {
            return res.send({
                code: isDone ? 200 : 400,
                msg: msg || isDone ? "验证成功" : "验证失败",
            });
        };
        this.expressEx = expressEx;
    }
}
exports.default = ExpressRes;
