"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Decs_1 = require("../types/Decs");
const fs = __importStar(require("fs"));
const pathOrigin = __importStar(require("path"));
// import zipper from "zip-local";
let _Fs = class _Fs {
    rmFile(filePath) {
        if (filePath instanceof Array) {
            return filePath.map((path) => this.rmFile(path));
        }
        else {
            fs.unlinkSync(filePath);
            return true;
        }
    }
    mkFile(path, data) {
        fs.writeFileSync(path, data, {});
        return true;
    }
    rmDir(path) {
        if (!fs.existsSync(path))
            return false;
        const files = fs.readdirSync(path);
        files.forEach((file) => {
            let curPath = path + "\\" + file;
            if (fs.statSync(curPath).isDirectory()) {
                this.rmDir(curPath);
            }
            else {
                fs.unlinkSync(curPath);
            }
        });
        fs.rmdirSync(path);
        return true;
    }
    mkDir(path) {
        fs.mkdirSync(path);
        return true;
    }
    readDir(path, options) {
        return fs.readdirSync(path, options);
    }
    readFile(path, options) {
        return fs.readFileSync(path, options);
    }
    getFileNamsByDir(path, back = ["js"], skipDirNames = ["node_modules"]) {
        if (!fs.existsSync(path))
            return;
        const paths = [];
        const files = fs.readdirSync(path);
        files.forEach((file) => {
            let curPath = pathOrigin.join(path, file);
            if (fs.statSync(curPath).isDirectory()) {
                if (skipDirNames.includes(file))
                    return;
                const list = this.getFileNamsByDir(curPath, back, skipDirNames);
                if (list === undefined)
                    return;
                paths.push(...list);
            }
            else {
                if (file.substring(0, 1) === ".")
                    return;
                if (back) {
                    const pathBack = curPath
                        .substr(curPath.lastIndexOf(".") + 1)
                        .toLowerCase();
                    if (back.includes(pathBack))
                        paths.push(curPath);
                }
                else {
                    paths.push(curPath);
                }
            }
        });
        return paths;
    }
    getAllFileNamsByDir(path) {
        if (!fs.existsSync(path))
            return;
        const paths = [];
        const files = this.readDir(path);
        console.log(files, "files");
        files.map((file) => {
            let curPath = pathOrigin.join(path, file);
            if (this.isDir(curPath)) {
                const list = this.getAllFileNamsByDir(curPath);
                if (list)
                    paths.push(...list);
            }
            paths.push(curPath);
        });
        return paths;
    }
    isHas(path) {
        return fs.existsSync(path);
    }
    getFileInfo(path) {
        if (!this.isHas(path))
            return false;
        const info = fs.statSync(path);
        return info;
    }
    isDir(path) {
        if (path instanceof Array) {
            for (const p of path) {
                if (!this.isDir(p))
                    return false;
            }
            return true;
        }
        else {
            const info = this.getFileInfo(path);
            if (!info)
                return false;
            return info.isDirectory();
        }
    }
    copyDirToDir(formDir, toDir, skips = ["node_modules"]) {
        const pms = [];
        if (!this.isDir(formDir))
            throw TypeError("路径为空");
        if (!this.isDir(toDir))
            this.mkDir(toDir);
        const files = this.readDir(formDir);
        files.map((path) => {
            if (skips.includes(path))
                return;
            const _src = formDir + "\\" + path;
            const _dst = toDir + "\\" + path;
            let readable;
            let writable;
            const srcInfo = this.getFileInfo(_src);
            if (srcInfo.isFile()) {
                const copyPms = new Promise((s) => {
                    readable = fs.createReadStream(_src);
                    writable = fs.createWriteStream(_dst);
                    readable.pipe(writable);
                    readable.on("end", () => {
                        s(0);
                    });
                });
                pms.push(copyPms);
            }
            else if (srcInfo.isDirectory()) {
                const childPms = this.copyDirToDir(_src, _dst);
                pms.push(...childPms);
            }
        });
        return pms;
    }
    // async zip(form: string, out?: string, getBuffer: boolean = false) {
    //   if (!this.isHas(form)) throw TypeError("输入或输出路径不正确");
    //   const fileName = this.getFileNameByPath(form);
    //   const outPut = (out || this.removeFileNameByPath(form)) + fileName + ".zip";
    //   return new Promise((s) => {
    //     zipper.zip(form, (error: any, zipped: any) => {
    //       if (error) return;
    //       zipped.compress();
    //       zipped.save(outPut);
    //       s({
    //         buffer: getBuffer && zipped.memory(),
    //         outPut,
    //       });
    //     });
    //   });
    // }
    removeFileNameByPath(path) {
        return path.substring(0, path.lastIndexOf("\\") + 1);
    }
    getFileNameByPath(path) {
        return path.substring(path.lastIndexOf("\\") + 1);
    }
};
_Fs = __decorate([
    (0, Decs_1.CatchClass)(false)
], _Fs);
exports.default = _Fs;
