"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("../src/fs"));
const fs = new fs_1.default();
const testFilePath = "./testaaa.txt";
test("rmDir", () => {
    !fs.isDir("./testaaa") && fs.mkDir("./testaaa");
    expect(fs.rmDir("./testaaa")).toBe(true);
    expect(fs.rmDir("./testaaaaaaaa")).toBe(false);
});
test("mkFile", () => {
    if (!fs.isHas(testFilePath)) {
        fs.mkFile(testFilePath, "123");
    }
    expect(fs.mkFile(testFilePath, "123")).toBe(true);
    if (fs.isHas(testFilePath)) {
        fs.rmFile(testFilePath);
    }
});
test("rmFile", () => {
    !fs.isHas("./testaaa.txt") && fs.mkFile("./testaaa.txt", "123");
    !fs.isHas("./testaaa1.txt") && fs.mkFile("./testaaa1.txt", "123");
    !fs.isHas("./testaaa2.txt") && fs.mkFile("./testaaa2.txt", "123");
    expect(fs.rmFile("./testaaa.txt")).toBe(true);
    expect(fs.rmFile("./testaaaaaaaa.txt")).toBe(false);
    expect(fs.rmFile(["./testaaaaaaaa.txt", "./testaaaaaaaa1.txt"])).toEqual([
        false,
        false,
    ]);
    expect(fs.rmFile(["./testaaa1.txt", "./testaaa2.txt"])).toEqual([true, true]);
});
test("mkDir", () => {
    expect(fs.mkDir("./testaaaa")).toBe(true);
    expect(fs.mkDir("./testaaaa")).toBe(false);
    fs.rmDir("./testaaaa");
});
test("readDir", () => {
    expect(fs.readDir("./testaaaa")).toBe(false);
    !fs.isDir("./testaaaa") && fs.mkDir("./testaaaa");
    expect(fs.readDir("./testaaaa")).toEqual([]);
    fs.rmDir("./testaaaa");
});
test("readFile", () => {
    !fs.isHas("./testaaa.txt") && fs.mkFile("./testaaa.txt", "123");
    expect(fs.readFile("./testaaa.txt", {
        encoding: "utf-8",
    })).toBe("123");
    fs.isHas("./testaaa.txt") && fs.rmFile("./testaaa.txt");
});
test("isHas", () => {
    expect(fs.isHas("./test")).toBe(true);
    expect(fs.isHas("./testaaaa")).toBe(false);
});
test("isDir", () => {
    expect(fs.isHas("./test")).toBe(true);
    expect(fs.isHas("./testaaaa")).toBe(false);
});
test("getFileNamsByDir", () => {
    if (!fs.isDir("testaaa")) {
        fs.mkDir("testaaa");
        fs.mkDir("./testaaa/bbb");
        fs.mkFile("./testaaa/bbb/test.txt", "123");
    }
    const res = fs.getFileNamsByDir("./testaaa", ["txt"]);
    expect(res).toContain("testaaa\\bbb\\test.txt");
    if (fs.isDir("testaaa")) {
        fs.rmDir("./testaaa");
    }
});
test("getAllFileNamsByDir", () => {
    if (!fs.isDir("testaaa")) {
        fs.mkDir("testaaa");
        fs.mkDir("./testaaa/bbb");
        fs.mkFile("./testaaa/bbb/test.txt", "123");
    }
    const res = fs.getAllFileNamsByDir("./testaaa");
    expect(res).toContain("testaaa\\bbb\\test.txt");
    expect(res).toContain("testaaa\\bbb");
    if (fs.isDir("testaaa")) {
        fs.rmDir("./testaaa");
    }
});
